#ifndef __MINIXML_TOOLS_BI__
#define __MINIXML_TOOLS_BI__

#ifndef __MINIXML_BI__ 
  #include once "minixml.bi"
#endif

' load node from memory (refcount is saet to 1)
function LoadXMLMemory(byval buffer as ubyte ptr,byval parent as mxml_node_t ptr=MXML_NO_PARENT) as mxml_node_t ptr
  if buffer=0 then return 0
  return mxmlLoadString(parent,buffer,MXML_NO_CALLBACK)
end function

' load node from file (refcount is saet to 1)
function LoadXMLFile(fileName as string,byval parent as mxml_node_t ptr=MXML_NO_PARENT) as mxml_node_t ptr
  var hFile = FreeFile()
  if open(fileName,for binary,access read,as #hFile)<>0 then return 0
  var nBytes = LOF(hFile)
  dim as ubyte ptr buffer = allocate(nBytes+1) ' alloc one byte more "\0"
  get #hFile,,*buffer,nBytes
  close #hFile
  buffer[nBytes]=0
  var node = LoadXMLMemory(buffer,parent)
  deallocate buffer
  return node
end function

' save node to memory (use Free() for deallocation)
function SaveXMLMemory(byval node as mxml_node_t ptr,byref nBytes as long) as ubyte ptr
  nBytes=0 : if node=0 then return 0
  dim as zstring ptr buffer = mxmlSaveAllocString(node,MXML_NO_CALLBACK)
  if buffer=0 then return 0
  nBytes=len(*buffer)
  return buffer
end function

function SaveXMLFile(fileName as string,byval node as mxml_node_t ptr) as long
  if node=0 then return 0
  dim as long nBytes
  ' save/create XML document in memory
  var buffer = SaveXMLMemory(node,nBytes)
  if buffer=0 then return 0
  var hFile = FreeFile()
  if open(fileName,for binary,access write,as #hFile)<>0 then 
    free(buffer) : return 0
  end if
  put #hFile,,*buffer,nBytes
  close #hFile
  free(buffer)
  return nBytes
end function

function NodeTypeAsString(typ as mxml_type_t) as string
  select case as const typ
  case MXML_ELEMENT : return "(0) ELEMENT"
  case MXML_INTEGER : return "(1) INTEGER"
  case MXML_OPAQUE  : return "(2) OPAQUE"
  case MXML_REAL    : return "(3) REAL"
  case MXML_TEXT    : return "(4) TEXT"
  case MXML_CUSTOM  : return "(5) CUSTOM"
  case else         : return "(" & typ & ") UNKNOW !"
  end select
end function

#endif ' __MINIXML_TOOLS_BI__
