#include once "minixml.bi"
#include once "minixml-tools.bi" ' <-- Load/SaveXMLFile, LoadSaveXMLMemory, NodeTypeAsString

sub parseELEMENT(byval node as mxml_node_t ptr)
  print "value.element.name " & *node->value.element.name
  if node->value.element.num_attrs>0 then
    for i as long=0 to node->value.element.num_attrs-1
      print "  attrs[" & i & "].name  = " & *node->value.element.attrs[i].name
      print "  attrs[" & i & "].value = " & *node->value.element.attrs[i].value
    next
  end if
end sub

sub parseTEXT(byval node as mxml_node_t ptr)
  'if node->value.text.whitespace=0 then
  if node->value.text.string andalso len(*node->value.text.string) then
    print "value.text.string " & * node->value.text.string
  end if
end sub

sub ParseNode(byval node as mxml_node_t ptr)
  if node=NULL then return
  select case node->type
  case MXML_IGNORE  : print !"\nMXML_IGNORE"
  case MXML_ELEMENT : parseELEMENT(node)
  case MXML_INTEGER : print !"\nMXML_INTEGER" ' parseINTEGER(node)
  case MXML_OPAQUE  : print !"\nMXML_OPAQUE"  ' parseOPAQUE(node)
  case MXML_REAL    : print !"\nMXML_REAL"    ' parseREAL(node)
  case MXML_TEXT    : parseTEXT(node)
  case MXML_CUSTOM  : print !"\nMXML_CUSTOM"  ' parseCUSTOM(node)
  case else
    print "unknow node type !"
    beep : sleep : end 1
  end select
  var Child = mxmlGetFirstChild(node)
  while Child
    var Sibling = mxmlGetNextSibling(Child)
    while Sibling
      ParseNode(Sibling)
      Sibling = mxmlGetNextSibling(Sibling)
    wend
    ParseNode(Child)
    Child = mxmlGetFirstChild(Child)
  wend
end sub

chdir exepath()

var root = LoadXMLFile("test.xml")
if root=NULL then
  print "error: LoadXMLFile() !"
  beep: sleep : end
end if
ParseNode(root)
mxmlRelease(root)
sleep
